;Toxic Kick Deluxe
;Created by Toxic Hellfire Staff
;http://www.toxic-hellfire.com

; Preset the Defaults so that when user first loads kick deluxe, adequate settings will be adjusted and toggled off.

on *:load:{
  set %kd.clone.1 7
  set %kd.clone.2 12
  set %kd.repeat.1 18
  set %kd.caps.1 22
  set %kd.toggle.1 28
  set %kd.toggle.2 30
  set %kd.toggle.3 32
}
menu channel,menubar {
  -
  Caps, flood, klonovi:/deluxe.dialog
}

alias -l deluxe.dialog {
  if ($dialog(deluxe) != $null) { dialog -v deluxe deluxe }
  else { dialog -m deluxe deluxe }
}

dialog deluxe {
  title "Toxic Kick Deluxe Suite 1.0 - General Preferences"
  option dbu
  size -1 -1 205 135
  button "&Ok",100, 119 106 40 15, ok
  button "&Cancel",101, 161 106 40 15, cancel

  box "Clone Kicker Options",1, 1 1 60 120
  box "Repeat Kicker Options",2, 63 1 139 30
  box "Caps Kicker Options",3, 63 35 139 25
  box "On / Off Toggle",4, 63 63 54 58

  ;----------------------
  ;     Clone 
  ;----------------------

  radio "Kick Only",7, 5 12 35 10, group 1
  radio "KickBan (30 sec)",8, 5 22 50 10
  radio "KickBan (60 sec)",9, 5 32 50 10
  radio "KickBan (5 min)",10, 5 42 47 10
  radio "KickBan (10 Min)",11, 5 52 50 10

  radio "Level Ban 1",12, 5 66 39 10, group 2
  radio "Level Ban 2",13, 5 76 39 10
  radio "Level Ban 3",14, 5 86 39 10
  radio "Level Ban 4",15, 5 96 39 10

  check "Deluxe Them",16, 5 110 42 10

  ;-----------------------
  ;     Repeat
  ;-----------------------

  radio "2 Repeats",17, 68 12 35 10, group 3
  radio "3 Repeats",18, 116 12 35 10
  radio "4 Repeats",19, 161 12 35 10

  ;------------------------
  ;       Caps
  ;------------------------

  radio "30% < ",20, 68 45 27 10, group 4
  radio "50% < ",21, 116 45 27 10
  radio "70% < ",22, 161 45 27 10

  ;------------------------
  ;     Toggles
  ;------------------------

  text "On      Off",23, 91 75 30 10
  text "Clone",24, 65 85 30 10
  text "Repeat",25, 65 95 30 10
  text "Caps",26, 65 105 30 10

  radio "",27, 91 85 7 10, group 5
  radio "",28, 107 85 7 10

  radio "",29, 91 95 7 10, group 6
  radio "",30, 107 95 7 10

  radio "",31, 91 105 7 10, group 7
  radio "",32, 107 105 7 10

  ;--------------------------
  ;    Description
  ;--------------------------

  text "Kick Deluxe is the premier in new age kick banning. Toggle the section on, then set the various settings for each type of kick, then press ok.",33, 120 65 80 40
}

;---------------------------------------------------
;  Kick Deluxe Command Section
;--------------------------------------------------

on *:dialog:deluxe:init:0: {
  did -c deluxe %kd.clone.1
  did -c deluxe %kd.clone.2 
  did -c deluxe %kd.repeat.1 
  did -c deluxe %kd.caps.1 
  did -c deluxe %kd.toggle.1 
  did -c deluxe %kd.toggle.2 
  did -c deluxe %kd.toggle.3 
}

; Ok Button Event
on *:dialog:deluxe:sclick:100: {
  if ($did(7).state == 1) { set %kd.clone.1 7 }
  if ($did(8).state == 1) { set %kd.clone.1 8 | set %bantime.clones 30 }
  if ($did(9).state == 1) { set %kd.clone.1 9 | set %bantime.clones 60 }
  if ($did(10).state == 1) { set %kd.clone.1 10 | set %bantime.clones 300 }
  if ($did(11).state == 1) { set %kd.clone.1 11 | set %bantime.clones 600 }
  if ($did(12).state == 1) { set %kd.clone.2 12 | set %banlevel.clones 1 }
  if ($did(13).state == 1) { set %kd.clone.2 13 | set %banlevel.clones 2 }
  if ($did(14).state == 1) { set %kd.clone.2 14 | set %banlevel.clones 3 }
  if ($did(15).state == 1) { set %kd.clone.2 15 | set %banlevel.clones 4 }
  if ($did(16).state == 1) { set %kd.clone.1 16 }
  if ($did(17).state == 1) { set %kd.repeat.1 17 | set %repeat.number 2 }
  if ($did(18).state == 1) { set %kd.repeat.1 18 | set %repeat.number 3 }
  if ($did(19).state == 1) { set %kd.repeat.1 19 | set %repeat.number 4 }
  if ($did(20).state == 1) { set %kd.caps.1 20 | set %caps.limit .3 }
  if ($did(21).state == 1) { set %kd.caps.1 21 | set %caps.limit .5 }
  if ($did(22).state == 1) { set %kd.caps.1 22 | set %caps.limit .7 }
  if ($did(27).state == 1) { set %kd.toggle.1 27 | .enable #kd.clone.group }
  if ($did(28).state == 1) { set %kd.toggle.1 28 | .disable #kd.clone.group }
  if ($did(29).state == 1) { set %kd.toggle.2 29 | .enable #kd.repeat.group }
  if ($did(30).state == 1) { set %kd.toggle.2 30 | .disable #kd.repeat.group }
  if ($did(31).state == 1) { set %kd.toggle.3 31 | .enable #kd.caps.group }
  if ($did(32).state == 1) { set %kd.toggle.3 32 | .disable #kd.caps.group }
}

;---------------------------------------------------------------
;              Caps Kicker Group
;---------------------------------------------------------------

#kd.caps.group off
on @*:TEXT:*:#:{
  var %caps.length = $strip($remove($1-,$chr(32)),burc)
  var %caps.length2 = $len(%caps.length)
  var %i = 0
  var %caps.total = 0
  if (%caps.length2 < 20) ||  ($nick isop #) || ( $chan == #pomoc ) { halt }
  :loop
  if (%i <= %caps.length2) { 
    inc %i 1 
    var %symbol = $asc($mid(%caps.length,%i,1))
    if ($asc($mid(%caps.length,%i,1)) isnum 65-90) { inc %caps.total 1 }
    if ($asc($mid(%caps.length,%i,1)) == $null) { goto end }
    if ((%symbol !isnum 97-122) && (%symbol !isnum 65-90)) { dec %caps.length2 1 } 
    goto loop
  }
  :end
  var %percentage.caps = $calc(%caps.total / %caps.length2)
  if (%percentage.caps >= %caps.limit) { 
  kick $nick  Iskljuchi CAPS Lock!  } 
}
#kd.caps.group end

#kd.caps.group2 on
on @*:ACTION:*:#:{
  var %caps.length = $strip($remove($1-,$chr(32)),burc)
  var %caps.length2 = $len(%caps.length)
  var %i = 0
  var %caps.total = 0
  if (%caps.length2 < 18) ||  ($nick isop #) || ( $chan == #pomoc ) || ( $chan == #useri ) || if ( $1- ison # ) { halt }
  :loop
  if (%i <= %caps.length2) { 
    inc %i 1 
    var %symbol = $asc($mid(%caps.length,%i,1))
    if ($asc($mid(%caps.length,%i,1)) isnum 65-90) { inc %caps.total 1 }
    if ($asc($mid(%caps.length,%i,1)) == $null) { goto end }
    if ((%symbol !isnum 97-122) && (%symbol !isnum 65-90)) { dec %caps.length2 1 } 
    goto loop
  }
  :end
  var %percentage.caps = $calc(%caps.total / %caps.length2)
  if (%percentage.caps >= %caps.limit) { 
  kick $nick  Iskljuchi CAPS lock!  } 
}
#kd.caps.group end


;---------------------------------------------------------------
;           Custom Label Identifier
;---------------------------------------------------------------

; Editing this Label is considered a breech of copyright law. So don't change it! ;)

alias -l deluxe {
  return 15.::[T]oxic7[12K7]ick[12D7]eluxe15::.
}

;---------------------------------------------------------------
;          Help File Load Alias
;---------------------------------------------------------------
alias kd.help {
  run $scriptdirreadme.txt
}
